=== validation/CMakeLists.txt ===
#                                               -*- cmake -*-

add_subdirectory (src)
