=== lib/test/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  Copyright 2005-2015 Airbus-EDF-IMACS-Phimeca
#
#  This library is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  along with this library.  If not, see <http://www.gnu.org/licenses/>.
#
#

set (NEW_PATH "${INSTALL_DESTDIR}${EXAMPLE_PATH}${PATH_SEP}$ENV{PATH}")

set (ADAPT_CHECK_TESTS_EXPONENT)
set (REPLACE_EOL " | cat ")
if (MINGW)
  # replace dos eols
  set (REPLACE_EOL " | tr -d '\\\\015' ")
  # By default, Mingw-g++ puts 3 digits to real exponent whereas g++ puts 2.
  set (ADAPT_CHECK_TESTS_EXPONENT "PRINTF_EXPONENT_DIGITS=2")

  if (CMAKE_SIZEOF_VOID_P EQUAL 4)
    add_library (CRT_fp8 STATIC CRT_fp8.c)
  endif ()
endif ()

set (CHECK_ENVIRONMENT "OPENTURNS_CONFIG_PATH=${CMAKE_BINARY_DIR}/lib/etc"
                        "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}"
                        ${ADAPT_CHECK_TESTS_EXPONENT} 
   )


set (EXCLUDE_TEST EXCLUDE_FROM_ALL)
if (INSTALL_TESTS)
  set (EXCLUDE_TEST "")

  macro (create_check_file FILE_NAME)
    file (WRITE ${FILE_NAME} "#!/bin/sh\n\n")
    file (APPEND ${FILE_NAME} "#set -e\n\n")
    #file (APPEND ${FILE_NAME} "#${CHECK_ENVIRONMENT}\n\n")
    file (APPEND ${FILE_NAME} "export PRINTF_EXPONENT_DIGITS=2\n")
    file (APPEND ${FILE_NAME} "export AUTOTEST_PATH=$PWD\n")
    file (APPEND ${FILE_NAME} "export OPENTURNS_CONFIG_PATH=$PWD/..\n")
    file (APPEND ${FILE_NAME} "#export OPENTURNS_LOG_SEVERITY=ALL\n")
    file (APPEND ${FILE_NAME} "DEBUG_FILE=stdouterr.dbg \n")
    file (APPEND ${FILE_NAME} "PATH=$PWD:$PWD/..:$PATH\n")
    file (APPEND ${FILE_NAME} "FAILED_TEST=\"\"\n\n")
    file (APPEND ${FILE_NAME} "function check_error {\nif [ \"$?\" != \"0\" ]; then\n  FAILED_TEST=\"$FAILED_TEST $1\"\n  echo \"std_err output:\"\n  cat $DEBUG_FILE\n  echo \"Test #$1: $2 failed!\"\n  echo\nfi\n}\n\n")
  endmacro (create_check_file FILE_NAME)

  macro (add_check_file FILE_NAME TESTNAME EXTERNAL_COMMAND CUR_CHECK)
    file (APPEND ${FILE_NAME} "echo \"Test #${CUR_CHECK}/$NB_CHECK: ${TESTNAME}\"\n")
    file (APPEND ${FILE_NAME} "${EXTERNAL_COMMAND}\n")
    file (APPEND ${FILE_NAME} "check_error ${CUR_CHECK} ${TESTNAME}\n\n")
  endmacro (add_check_file FILE_NAME TESTNAME EXTERNAL_COMMAND CUR_CHECK)

  macro (finish_check_file FILE_NAME NB_CHECK)
    file (APPEND ${FILE_NAME} "}\n\n")
    file (APPEND ${FILE_NAME} "NB_CHECK=${NB_CHECK}\n")
    file (APPEND ${FILE_NAME} "start_tests\necho\n")
    file (APPEND ${FILE_NAME} "RC=0\nif [ \"$FAILED_TEST\" = \"\" ]; then\n  echo \"Every check tests are OK.\"\n")
    file (APPEND ${FILE_NAME} "else\n  echo \"Tests$FAILED_TEST failed!\"\n  RC=1\nfi\n")
    file (APPEND ${FILE_NAME} "exit $RC\n")
  endmacro (finish_check_file FILE_NAME)

  # create a standalone sh file that can launch tests
  set (EXTERNAL_CHECK_FILE "${CMAKE_CURRENT_BINARY_DIR}/start_check_test.sh")
  create_check_file (${EXTERNAL_CHECK_FILE})
  file (APPEND ${EXTERNAL_CHECK_FILE} "\nstart_tests() {\n")
  set (CUR_CHECK 0)
  
endif ()

  
# This macro compiles on the fly and run the corresponding pre-installation test
# It can have two optional arguments PRE and POST followed by some shell command to be run
# before or after the test if needed
# PRE and POST options cn be repeated many times: the arguments will be run one after the other
# in the order of appearence. If one fails, the whole command fails.
set (CHECK_TO_BE_RUN)
macro (ot_check_test TESTNAME)
  set (TESTNAME_TGT t_${TESTNAME})
  set (TESTNAME_SRC ${TESTNAME_TGT}.cxx)
  set (TESTNAME_SRCS ${TESTNAME_SRC})
  add_executable (${TESTNAME_TGT} ${EXCLUDE_TEST} ${TESTNAME_SRCS})
  add_dependencies(tests ${TESTNAME_TGT}) 
  target_link_libraries (${TESTNAME_TGT} OT)
  if (MINGW AND CMAKE_SIZEOF_VOID_P EQUAL 4)
    target_link_libraries (${TESTNAME_TGT} CRT_fp8)
  endif ()
  set_target_properties (${TESTNAME_TGT} PROPERTIES
                                          INSTALL_RPATH "${CMAKE_BINARY_DIR}/lib/src;${CMAKE_INSTALL_RPATH}")
  set (TESTNAME_LOC ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}${CMAKE_EXECUTABLE_SUFFIX})

  set (_CMD)
  set (_PRE)
  set (_POST)
  set (_PARAMS)
  set (_IGNOREOUT OFF)
  foreach (_ARG ${ARGN})
    string (TOUPPER ${_ARG} ARG)
    if (${ARG} MATCHES PRE)
      set (_CMD PRE)
    elseif (${ARG} MATCHES POST)
      set (_CMD POST)
    elseif (${ARG} MATCHES PARAMS)
      set (_CMD PARAMS)
    elseif (${ARG} MATCHES IGNOREOUT)
      set (_IGNOREOUT ON)
    else (${ARG} MATCHES PRE)
      if (${_CMD} MATCHES PRE)
        set (_PRE "${_PRE} ${_ARG} && ")
      elseif (${_CMD} MATCHES POST)
        set (_POST "${_POST} && ${_ARG}")
      elseif (${_CMD} MATCHES PARAMS)
        set (_PARAMS "${_PARAMS} ${_ARG}")
      endif  (${_CMD} MATCHES PRE)
      set (_CMD)
    endif (${ARG} MATCHES PRE)
  endforeach (_ARG)

  if (_IGNOREOUT)
    set (COMMAND "(${TESTNAME_LOC} ${_PARAMS} > /dev/null)")
    set (EXTERNAL_COMMAND "./${TESTNAME_TGT} ${_PARAMS} > $DEBUG_FILE 2>&1")
  else (_IGNOREOUT)
    set (TESTNAME_OUT ${TESTNAME_TGT}.expout)
    set (OUTFILE_LOC ${CMAKE_CURRENT_SOURCE_DIR}/${TESTNAME_OUT})
    set (COMMAND "(${TESTNAME_LOC} ${_PARAMS} ${REPLACE_EOL} > ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out) && diff -u ${OUTFILE_LOC} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out")
    set (EXTERNAL_COMMAND "(./${TESTNAME_TGT} ${_PARAMS} 2>$DEBUG_FILE | tr -d '\\\\r' > ${TESTNAME_TGT}.out) && diff -u ${TESTNAME_OUT} ${TESTNAME_TGT}.out")
  endif (_IGNOREOUT)

  if (_PRE OR _POST)
    set (COMMAND "${_PRE}${COMMAND}${_POST}")
    set (EXTERNAL_COMMAND "${_PRE}${EXTERNAL_COMMAND}${_POST}")
  endif (_PRE OR _POST)

  add_test (cppcheck_${TESTNAME} "sh" "-c" "${COMMAND}")
  set_tests_properties (cppcheck_${TESTNAME} PROPERTIES ENVIRONMENT "${CHECK_ENVIRONMENT}")
  list (APPEND CHECK_TO_BE_RUN ${TESTNAME_TGT})
  install (FILES ${TESTNAME_SRC}
            DESTINATION ${EXAMPLE_PATH} 
         )

  if (INSTALL_TESTS)
    install (FILES ${TESTNAME_OUT}
              DESTINATION ${EXAMPLE_PATH} 
           )
    install (TARGETS ${TESTNAME_TGT}
              DESTINATION ${EXAMPLE_PATH} 
           )

    add_check_file (${EXTERNAL_CHECK_FILE} ${TESTNAME_TGT} ${EXTERNAL_COMMAND} ${CUR_CHECK})
    math(EXPR CUR_CHECK "${CUR_CHECK} + 1")
  endif ()

endmacro (ot_check_test)


include_directories (${INTERNAL_INCLUDE_DIRS})

## Pre-installation tests

# Common
ot_check_test (Object_std)
ot_check_test (OStream_std)
ot_check_test (PersistentObject_std)
ot_check_test (Pointer_std)
ot_check_test (Pointer_cast)
ot_check_test (Exception_std)
ot_check_test (Log_std)
ot_check_test (IdFactory_std IGNOREOUT)
ot_check_test (ComparisonOperator_std)
if (LIBXML2_FOUND)
ot_check_test (Study_saveload )
endif ()
ot_check_test (ResourceMap_std IGNOREOUT)
ot_check_test (Catalog_std IGNOREOUT)
ot_check_test (AtomicFunctions_std IGNOREOUT)

# Type
ot_check_test (Collection_std)
ot_check_test (Indices_std)
ot_check_test (Description_std)
ot_check_test (NumericalPoint_std)
ot_check_test (NumericalPoint_description)
ot_check_test (Matrix_std)
ot_check_test (IdentityMatrix_std)
ot_check_test (Tensor_std)
ot_check_test (ComplexTensor_std)
ot_check_test (SymmetricTensor_std)
ot_check_test (SquareMatrix_std)
ot_check_test (TriangularMatrix_std)
ot_check_test (SymmetricMatrix_std)
ot_check_test (Matrix_solve)
ot_check_test (Matrix_decomposition)
ot_check_test (SquareMatrix_lapack)
ot_check_test (SymmetricMatrix_lapack)
ot_check_test (Cache_std)
ot_check_test (ComplexMatrix_std)
ot_check_test (SquareComplexMatrix_std)
ot_check_test (HermitianMatrix_std)
ot_check_test (TriangularComplexMatrix_std)

# Func
ot_check_test (LinearNumericalMathEvaluationImplementation_std)
ot_check_test (ConstantNumericalMathGradientImplementation_std)
ot_check_test (AggregatedNumericalMathEvaluationImplementation_std)
ot_check_test (PiecewiseLinearEvaluationImplementation_std)
ot_check_test (PiecewiseHermiteEvaluationImplementation_std)
ot_check_test (P1LagrangeEvaluationImplementation_std)
if (OPENTURNS_HAVE_MUPARSER)
ot_check_test (AnalyticalNumericalMathEvaluationImplementation_std)
ot_check_test (AnalyticalNumericalMathGradientImplementation_std)
ot_check_test (AnalyticalNumericalMathHessianImplementation_std)
endif ()
ot_check_test (LinearNumericalMathFunction_std)
ot_check_test (LinearCombinationEvaluationImplementation_std)
ot_check_test (LinearCombinationGradientImplementation_std)
ot_check_test (LinearCombinationHessianImplementation_std)
ot_check_test (QuadraticNumericalMathEvaluationImplementation_std)
ot_check_test (LinearNumericalMathGradientImplementation_std)
ot_check_test (ConstantNumericalMathHessianImplementation_std)
ot_check_test (MethodBoundNumericalMathEvaluationImplementation_std)
ot_check_test (NumericalMathFunction_analytical)
ot_check_test (NumericalMathFunction_indicator)
ot_check_test (NumericalMathFunction_aggregated)
ot_check_test (NumericalMathFunction_dual_linear_combination)
ot_check_test (NumericalMathFunction_linear_combination)
ot_check_test (NumericalMathFunction_operations)
ot_check_test (NumericalMathFunction_parametric)
ot_check_test (NumericalMathFunction_data)
ot_check_test (NumericalMathFunction_history)

if (R_base_FOUND)
ot_check_test (NumericalMathFunction_draw)
endif ()
ot_check_test (UniVariatePolynomial_std)
ot_check_test (Basis_std)
ot_check_test (BasisSequence_std)
ot_check_test (LAR_std)
ot_check_test (DynamicalFunction_std)
ot_check_test (SpatialFunction_std)
ot_check_test (TemporalFunction_std)
ot_check_test (BoxCoxEvaluationImplementation_std)
ot_check_test (BoxCoxTransform_std)
ot_check_test (InverseBoxCoxEvaluationImplementation_std)
ot_check_test (InverseBoxCoxTransform_std)
ot_check_test (TrendEvaluationImplementation_std)
ot_check_test (TrendTransform_std)
ot_check_test (InverseTrendEvaluationImplementation_std)
ot_check_test (InverseTrendTransform_std)
ot_check_test (ExpertMixture_std)
ot_check_test (BasisFactory_std)

# Optim
ot_check_test (AbdoRackwitz_std)
ot_check_test (Cobyla_std)
ot_check_test (SQP_std)
ot_check_test (TNC_std)
ot_check_test (NearestPointChecker_std)

# Solver
ot_check_test (Bisection_std)
ot_check_test (Brent_std)
ot_check_test (Secant_std)
ot_check_test (RungeKutta_std)

# Stat
ot_check_test (NumericalSample_std)
ot_check_test (NumericalSample_split)
ot_check_test (NumericalSample_large)
ot_check_test (NumericalSample_computation)
ot_check_test (NumericalSample_operators)
ot_check_test (HistoryStrategy_std)
ot_check_test (CovarianceMatrixLapack_std)
ot_check_test (CorrelationMatrix_std)
ot_check_test (TestResult_std)
if (R_rot_FOUND)
ot_check_test (LinearModelFactory_std)
ot_check_test (LinearModel_std)
endif ()
ot_check_test (SensitivityAnalysis_std)
ot_check_test (ProcessSample_std)
ot_check_test (RandomGenerator_std)
ot_check_test (SobolSequence_std)
ot_check_test (FaureSequence_std)
ot_check_test (HaltonSequence_std)
ot_check_test (HaselgroveSequence_std)
ot_check_test (ReverseHaltonSequence_std)
ot_check_test (CorrelationAnalysis_std)
ot_check_test (TimeSeries_std)
ot_check_test (ExponentialCauchy_std)
ot_check_test (FilteringWindows_std)
ot_check_test (WelchFactory_std)
ot_check_test (ExponentialModel_std)
ot_check_test (DiracCovarianceModel_std)
ot_check_test (ExponentiallyDampedCosineModel_std)
ot_check_test (CauchyModel_std)
ot_check_test (SecondOrderModel_std)
ot_check_test (UserDefinedSpectralModel_std)
ot_check_test (UserDefinedCovarianceModel_std)
ot_check_test (UserDefinedStationaryCovarianceModel_std)
