=== python/test/CMakeLists.txt ===
#                                               -*- cmake -*-

set (NEW_PATH "$ENV{PATH}:${INSTALL_DESTDIR}${EXAMPLE_PATH}")

set (ADAPT_CHECK_TESTS_EXPONENT)
set (REPLACE_EOL " | cat ")
if (MINGW)
  # replace dos eols
  set (REPLACE_EOL " | tr -d '\\\\015' ")
  # By default, Mingw-g++ puts 3 digits to real exponent whereas g++ puts 2.
  set (ADAPT_CHECK_TESTS_EXPONENT "PRINTF_EXPONENT_DIGITS=2")
endif ()


set (PYINSTALLCHECK_ENVIRONMENT "AUTOTEST_PATH=${INSTALL_DESTDIR}${EXAMPLE_PATH}"
                                 "OPENTURNS_CONFIG_PATH=${INSTALL_DESTDIR}${SYSCONFIG_PATH}/openturns"
                                 "PATH=${NEW_PATH}"
                                 "LD_LIBRARY_PATH=${INSTALL_DESTDIR}${LIBRARY_PATH}:$ENV{LD_LIBRARY_PATH}"
                                 "PYTHONPATH=${INSTALL_DESTDIR}${PYTHON_MODULE_PATH}${PATH_SEP}$ENV{PYTHONPATH}"
                                 ${ADAPT_CHECK_TESTS_EXPONENT}
   )

if (MINGW)
  macro (create_check_file FILE_NAME)
    file (WRITE ${FILE_NAME} "#!/bin/sh\n\n")
    file (APPEND ${FILE_NAME} "#set -e\n\n")
    #file (APPEND ${FILE_NAME} "#${CHECK_ENVIRONMENT}\n\n")
    file (APPEND ${FILE_NAME} "export PRINTF_EXPONENT_DIGITS=2\n")
    file (APPEND ${FILE_NAME} "export AUTOTEST_PATH=$PWD\n")
    file (APPEND ${FILE_NAME} "export OPENTURNS_CONFIG_PATH=$PWD/..\n")
    file (APPEND ${FILE_NAME} "#export OPENTURNS_LOG_SEVERITY=ALL\n")
    file (APPEND ${FILE_NAME} "DEBUG_FILE=stdouterr.dbg \n")
    file (APPEND ${FILE_NAME} "export OPENTURNS_HOME=$PWD/..\n")
    file (APPEND ${FILE_NAME} "PATH=$PWD:$PWD/..:$PATH\n")
    file (APPEND ${FILE_NAME} "PYTHON_EXE=../../../../python.exe\n\n")
    file (APPEND ${FILE_NAME} "FAILED_TEST=\"\"\n")
    file (APPEND ${FILE_NAME} "function check_error {\nif [ \"$?\" != \"0\" ]; then\n  FAILED_TEST=\"$FAILED_TEST $1\"\n  echo \"std_err output:\"\n  cat $DEBUG_FILE\n  echo \"Test #$1: $2 failed!\"\n  echo\nfi\n}\n\n")
  endmacro (create_check_file FILE_NAME)

  macro (add_check_file FILE_NAME TESTNAME EXTERNAL_COMMAND CUR_CHECK)
    file (APPEND ${FILE_NAME} "echo \"Test #${CUR_CHECK}/$NB_CHECK: ${TESTNAME}\"\n")
    file (APPEND ${FILE_NAME} "${EXTERNAL_COMMAND}\n")
    file (APPEND ${FILE_NAME} "check_error ${CUR_CHECK} ${TESTNAME}\n\n")
  endmacro (add_check_file FILE_NAME TESTNAME EXTERNAL_COMMAND CUR_CHECK)

  macro (finish_check_file FILE_NAME NB_CHECK)
    file (APPEND ${FILE_NAME} "}\n\n")
    file (APPEND ${FILE_NAME} "NB_CHECK=${NB_CHECK}\n")
    file (APPEND ${FILE_NAME} "start_tests\necho\n")
    file (APPEND ${FILE_NAME} "RC=0\nif [ \"$FAILED_TEST\" = \"\" ]; then\n  echo \"Every check tests are OK.\"\n")
    file (APPEND ${FILE_NAME} "else\n  echo \"Tests$FAILED_TEST failed!\"\n  RC=1\nfi\n")
    file (APPEND ${FILE_NAME} "exit $RC\n")
  endmacro (finish_check_file FILE_NAME)


  set (EXTERNAL_PYTHONINSTALLCHECK_FILE "${CMAKE_CURRENT_BINARY_DIR}/start_pythoninstallcheck_test.sh")
  create_check_file (${EXTERNAL_PYTHONINSTALLCHECK_FILE})
  #file (APPEND ${EXTERNAL_PYTHONINSTALLCHECK_FILE} "#${INSTALLCHECK_ENVIRONMENT}\n\n")
  #file (APPEND ${EXTERNAL_PYTHONINSTALLCHECK_FILE} "export abs_srcdir=$PWD\n")
  file (APPEND ${EXTERNAL_PYTHONINSTALLCHECK_FILE} "start_tests() {\n")
  set (CUR_PYTHONINSTALLCHECK 0)

endif ()

# This macro compiles on the fly and run the corresponding post-installation test
# It can have two optional arguments PRE and POST followed by some shell command to be run
# before or after the test if needed
# PRE and POST options cn be repeated many times: the arguments will be run one after the other
# in the order of appearence. If one fails, the whole command fails.
set (PYINSTALLCHECK_TO_BE_RUN)
macro (ot_pyinstallcheck_test TESTNAME)
  set (TESTNAME_TGT t_${TESTNAME})
  set (TESTNAME_SRC ${TESTNAME_TGT}.py)
  set (TESTNAME_LOC ${CMAKE_CURRENT_SOURCE_DIR}/${TESTNAME_SRC})
  set (_CMD)
  set (_PRE)
  set (_POST)
  set (_PARAMS)
  set (_IGNOREOUT OFF)
  foreach (_ARG ${ARGN})
    string (TOUPPER ${_ARG} ARG)
    if (${ARG} MATCHES PRE)
      set (_CMD PRE)
    elseif (${ARG} MATCHES POST)
      set (_CMD POST)
    elseif (${ARG} MATCHES PARAMS)
      set (_CMD PARAMS)
    elseif (${ARG} MATCHES IGNOREOUT)
      set (_IGNOREOUT ON)
    else (${ARG} MATCHES PRE)
      if (${_CMD} MATCHES PRE)
        set (_PRE "${_PRE} ${_ARG} && ")
      elseif (${_CMD} MATCHES POST)
        set (_POST "${_POST} && ${_ARG}")
      elseif (${_CMD} MATCHES PARAMS)
        set (_PARAMS "${_PARAMS} ${_ARG}")
      endif  (${_CMD} MATCHES PRE)
      set (_CMD)
    endif (${ARG} MATCHES PRE)
  endforeach (_ARG)
  
  if (_IGNOREOUT)
    set (COMMAND "(${PYTHON_EXECUTABLE} ${TESTNAME_LOC} ${_PARAMS} > /dev/null)")
    set (EXTERNAL_COMMAND "$PYTHON_EXE ${TESTNAME_SRC} > $DEBUG_FILE 2>&1")
  else (_IGNOREOUT)
    set (TESTNAME_OUT ${TESTNAME_TGT}.expout)
    get_source_file_property (OUTFILE_LOC ${TESTNAME_OUT} LOCATION)
    set (OUTFILE_LOC ${CMAKE_CURRENT_SOURCE_DIR}/${TESTNAME_OUT})
    set (COMMAND "(${PYTHON_EXECUTABLE} ${TESTNAME_LOC} ${_PARAMS} ${REPLACE_EOL} > ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out) && diff -u ${OUTFILE_LOC} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out")
    set (EXTERNAL_COMMAND "($PYTHON_EXE ${TESTNAME_SRC} 2>$DEBUG_FILE | tr -d '\\\\r' > ${TESTNAME_TGT}.out) && diff -u ${TESTNAME_SRC}.expout ${TESTNAME_TGT}.out")
  endif (_IGNOREOUT)

  if (_PRE OR _POST)
    set (COMMAND "${_PRE}${COMMAND}${_POST}")
    #not useful
    #set (EXTERNAL_COMMAND "${_PRE}${EXTERNAL_COMMAND}${_POST}")
  endif (_PRE OR _POST)

  add_test (pyinstallcheck_${TESTNAME} "sh" "-c" "${COMMAND}")

  if (INSTALL_TESTS)
    install (FILES ${TESTNAME_OUT}
              DESTINATION ${EXAMPLE_PATH} 
              RENAME ${TESTNAME_SRC}.expout
           )
          add_check_file (${EXTERNAL_PYTHONINSTALLCHECK_FILE} ${TESTNAME_SRC} ${EXTERNAL_COMMAND} ${CUR_PYTHONINSTALLCHECK})
    math(EXPR CUR_PYTHONINSTALLCHECK "${CUR_PYTHONINSTALLCHECK} + 1")
  endif ()


  set_tests_properties (pyinstallcheck_${TESTNAME} PROPERTIES ENVIRONMENT "${PYINSTALLCHECK_ENVIRONMENT}")
  list (APPEND PYINSTALLCHECK_TO_BE_RUN ${TESTNAME_SRC})
  install (FILES ${TESTNAME_SRC}
            DESTINATION ${EXAMPLE_PATH} 
            PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE
         )
endmacro (ot_pyinstallcheck_test)


## Python post-installation tests

# Common
if (LIBXML2_FOUND)
  ot_pyinstallcheck_test (Object_pickle)
endif ()
ot_pyinstallcheck_test (ComparisonOperator_std)
if (LIBXML2_FOUND)
ot_pyinstallcheck_test (Study_saveload)
endif ()
ot_pyinstallcheck_test (Path_std IGNOREOUT)
ot_pyinstallcheck_test (ResourceMap_std IGNOREOUT)
ot_pyinstallcheck_test (Catalog_std IGNOREOUT)

# Type
ot_pyinstallcheck_test (Collection_std)
ot_pyinstallcheck_test (Description_std)
ot_pyinstallcheck_test (Indices_std)
ot_pyinstallcheck_test (NumericalPoint_std)
ot_pyinstallcheck_test (NumericalPoint_description)
ot_pyinstallcheck_test (Matrix_std)
ot_pyinstallcheck_test (SymmetricMatrix_lapack)
ot_pyinstallcheck_test (SquareMatrix_lapack)
ot_pyinstallcheck_test (SquareMatrix_std)
ot_pyinstallcheck_test (TriangularMatrix_std)
ot_pyinstallcheck_test (SymmetricMatrix_std)
ot_pyinstallcheck_test (Tensor_std)
ot_pyinstallcheck_test (ComplexTensor_std)
ot_pyinstallcheck_test (SymmetricTensor_std)
ot_pyinstallcheck_test (Matrix_solve)
ot_pyinstallcheck_test (Matrix_decomposition)
ot_pyinstallcheck_test (IdentityMatrix_std)
ot_pyinstallcheck_test (RegularGrid_std)
ot_pyinstallcheck_test (ComplexMatrix_std)
ot_pyinstallcheck_test (SquareComplexMatrix_std)
ot_pyinstallcheck_test (HermitianMatrix_std)
ot_pyinstallcheck_test (TriangularComplexMatrix_std)
ot_pyinstallcheck_test (Matrix_slice)
ot_pyinstallcheck_test (Matrix_operators)
if (NUMPY_FOUND)
  ot_pyinstallcheck_test (Matrix_numpy)
endif ()

# Func
ot_pyinstallcheck_test (NumericalMathFunction_std)
ot_pyinstallcheck_test (NumericalMathFunction_composition)
ot_pyinstallcheck_test (NumericalMathFunction_python)
if (LIBXML2_FOUND)
ot_pyinstallcheck_test (NumericalMathFunction_python_saveload)
endif ()
ot_pyinstallcheck_test (NumericalMathFunction_data)
ot_pyinstallcheck_test (NumericalMathFunction_operations)
ot_pyinstallcheck_test (NumericalMathFunction_parametric)

if (R_base_FOUND)
ot_pyinstallcheck_test (NumericalMathFunction_draw)
endif ()
ot_pyinstallcheck_test (NumericalMathFunction_history)
ot_pyinstallcheck_test (AggregatedNumericalMathEvaluationImplementation_std)
ot_pyinstallcheck_test (AnalyticalNumericalMathEvaluationImplementation_std)
ot_pyinstallcheck_test (AnalyticalNumericalMathGradientImplementation_std)
ot_pyinstallcheck_test (AnalyticalNumericalMathHessianImplementation_std)
ot_pyinstallcheck_test (LinearNumericalMathFunction_std)
ot_pyinstallcheck_test (LinearNumericalMathEvaluationImplementation_std)
ot_pyinstallcheck_test (LinearCombinationEvaluationImplementation_std)
ot_pyinstallcheck_test (LinearCombinationGradientImplementation_std)
ot_pyinstallcheck_test (LinearCombinationHessianImplementation_std)
ot_pyinstallcheck_test (PiecewiseLinearEvaluationImplementation_std)
ot_pyinstallcheck_test (PiecewiseHermiteEvaluationImplementation_std)
ot_pyinstallcheck_test (QuadraticNumericalMathEvaluationImplementation_std)
ot_pyinstallcheck_test (LinearNumericalMathGradientImplementation_std)
ot_pyinstallcheck_test (NumericalMathFunction_aggregated)
ot_pyinstallcheck_test (NumericalMathFunction_analytical)
ot_pyinstallcheck_test (NumericalMathFunction_dual_linear_combination)
ot_pyinstallcheck_test (NumericalMathFunction_indicator)
ot_pyinstallcheck_test (NumericalMathFunction_linear_combination)
ot_pyinstallcheck_test (ConstantNumericalMathGradientImplementation_std)
ot_pyinstallcheck_test (ConstantNumericalMathHessianImplementation_std)
ot_pyinstallcheck_test (ConstantNumericalMathHessianImplementation_std)
ot_pyinstallcheck_test (ConstantNumericalMathHessianImplementation_std)
ot_pyinstallcheck_test (Basis_std)
ot_pyinstallcheck_test (BasisSequence_std)
ot_pyinstallcheck_test (LAR_std)
ot_pyinstallcheck_test (DynamicalFunction_std)
ot_pyinstallcheck_test (SpatialFunction_std)
ot_pyinstallcheck_test (TemporalFunction_std)
ot_pyinstallcheck_test (BoxCoxEvaluationImplementation_std)
ot_pyinstallcheck_test (BoxCoxTransform_std)
ot_pyinstallcheck_test (InverseBoxCoxEvaluationImplementation_std)
ot_pyinstallcheck_test (InverseBoxCoxTransform_std)
ot_pyinstallcheck_test (TrendEvaluationImplementation_std)
ot_pyinstallcheck_test (TrendTransform_std)
ot_pyinstallcheck_test (InverseTrendEvaluationImplementation_std)
ot_pyinstallcheck_test (InverseTrendTransform_std)
ot_pyinstallcheck_test (ExpertMixture_std)
ot_pyinstallcheck_test (UniVariatePolynomial_std)
ot_pyinstallcheck_test (BasisFactory_std)
ot_pyinstallcheck_test (Field_std)

# Stat
ot_pyinstallcheck_test (NumericalSample_std)
ot_pyinstallcheck_test (NumericalSample_computation)
ot_pyinstallcheck_test (NumericalSample_slice)
ot_pyinstallcheck_test (NumericalSample_split)
ot_pyinstallcheck_test (NumericalSample_large)
ot_pyinstallcheck_test (NumericalSample_bug14)
ot_pyinstallcheck_test (NumericalSample_csv)
ot_pyinstallcheck_test (NumericalSample_operators)
ot_pyinstallcheck_test (HistoryStrategy_std)
ot_pyinstallcheck_test (CovarianceMatrixLapack_std)
ot_pyinstallcheck_test (CorrelationMatrix_std)
if (R_rot_FOUND)
ot_pyinstallcheck_test (LinearModel_std)
ot_pyinstallcheck_test (LinearModelFactory_std)
endif ()
ot_pyinstallcheck_test (ProcessSample_std)
ot_pyinstallcheck_test (RandomGenerator_std)
ot_pyinstallcheck_test (SobolSequence_std)
ot_pyinstallcheck_test (FaureSequence_std)
ot_pyinstallcheck_test (HaltonSequence_std)
ot_pyinstallcheck_test (HaselgroveSequence_std)
ot_pyinstallcheck_test (ReverseHaltonSequence_std)
ot_pyinstallcheck_test (TestResult_std)
ot_pyinstallcheck_test (SensitivityAnalysis_std)
ot_pyinstallcheck_test (CorrelationAnalysis_std)
ot_pyinstallcheck_test (TimeSeries_std)
ot_pyinstallcheck_test (ExponentialCauchy_std)
