=== debian/changelog ===
openturns (1.7-3ubuntu1) artful; urgency=medium

  * Build with -ffloat-store on i386.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 14 Aug 2017 14:14:01 -0700

openturns (1.7-3build2) artful; urgency=medium

  * No-change rebuild for GCC 7 abi mangling change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 07 Aug 2017 15:21:21 +0000

openturns (1.7-3build1) artful; urgency=medium

  * No-change rebuild to build with python3.6.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 24 Jul 2017 14:08:10 +0000

openturns (1.7-3) unstable; urgency=medium

  * Team upload.
  * Keep swig files only in libopenturns-dev, not also in python-openturns-dev.
    Closes: #826688

 -- Mattia Rizzolo <mattia@debian.org>  Tue, 21 Jun 2016 08:16:28 +0000

openturns (1.7-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * debian/control: Use https in Vcs-* fields.

 -- Mattia Rizzolo <mattia@debian.org>  Mon, 20 Jun 2016 19:34:28 +0000

openturns (1.7-1) experimental; urgency=medium

  [ Julien Schueller ]
  * New upstream release.

  [ Denis Barbier ]
  * debian/docs: Remove ChangeLog, this file is already copied
    by dh_installchangelogs.

 -- Denis Barbier <barbier@debian.org>  Sun, 05 Jun 2016 17:54:45 +0100

openturns (1.7~rc1-1) experimental; urgency=low

  [ Julien Schueller ]
  * New upstream pre-release.

 -- Denis Barbier <barbier@debian.org>  Thu, 10 Dec 2015 18:14:47 +0100

openturns (1.6-1) experimental; urgency=low

  [ Julien Schueller ]
  * New upstream release.

 -- Denis Barbier <barbier@debian.org>  Thu, 13 Aug 2015 18:14:47 +0200

openturns (1.6~rc1-1) experimental; urgency=low

  [ Julien Schueller ]
  * New upstream pre-release.

 -- Denis Barbier <barbier@debian.org>  Mon, 16 Jun 2015 16:34:47 +0100
